<script>
import useColumns from "./columns";
import { ADD, CODE, LINKAGREEMENT } from "@/api/business/purchase/contract";
import { tax, currency } from "@/components/popover-select-v2/fetch";

export default {
  name: "AddFormModel",
  props: {
    selectData: {
      type: [Array],
      require: true,
    },
    dict: {
      type: Object,
      require: true,
    },
    title: {
      type: String,
    },
  },
  components: {
    ElSuperForm: () => import("@/components/super-form/index.vue"),
    ElSuperTable: () => import("@/components/super-table/index.vue"),
    ElPopoverSelectV2: () => import("@/components/popover-select-v2/index.vue"),
  },
  data() {
    const {
      TabColumns,
      TableColumns,
      TabColumns: [
        {
          item: { key: tabName },
        },
      ],
    } = useColumns();
    const rules = this.$init.rules([...TabColumns, ...TableColumns]);
    console.log(rules,'rules------------');
    const params = this.$init.params([...TabColumns, ...TableColumns]);
    return {
      loading: false,
      loadingText: "",
      rules: rules,
      params: params,
      tabName: tabName,
      TabColumns: TabColumns,
      TableColumns: TableColumns,
    };
  },
  computed: {},
  watch: {
    "params.isRebate": {
      handler: function (newValue) {
        if (newValue === "Y") {
          this.rules.rebatePolicy = [
            { required: true, message: "返利政策不能为空", trigger: "change" },
          ];
        } else {
          this.rules.rebatePolicy = null;
        }
      },
      immediate: true,
    },
    "params.isTarget": {
      handler: function (newValue) {
        if (newValue === "Y") {
          this.rules.contractTarget = [
            { required: true, message: "合同指标不能为空", trigger: "change" },
          ];
        } else {
          this.rules.contractTarget = null;
        }
      },
      immediate: true,
    },
    "params.effectiveDate": {
      handler: function (newValue) {
        if (!newValue) {
          this.params.endDate = null;
        }
        this.rules.endDate = [
          {
            validator: (rule, value, callback) => {
              if (!newValue) {
                callback(new Error("合同生效日期不能为空"));
              } else if (!value) {
                callback(new Error("合同失效日期不能为空"));
              } else if (
                new Date(value).getTime() <
                new Date(newValue).getTime() + 24 * 1000 * 3600
              ) {
                callback(new Error("合同失效日期必须大于合同生效日期！"));
              } else {
                callback();
              }
            },
            trigger: "change",
          },
        ];
      },
      immediate: true,
    },
  },
  methods: {
    //
    getTabTableColumnParams(prop) {
      const { TableColumns } = this.TabColumns.find(
        ({ item: { key } }) => key === prop
      );
      return this.$init.params(TableColumns);
    },
    //
    async changePaymentAgreement(prop) {
      console.log('合同参数', prop)
      const {
        selectData: { code },
      } = prop;
      const { data } = await LINKAGREEMENT(code);
      this.tabName = "contractAgreementList";
      this.params.contractAgreementList.push({
        ...this.getTabTableColumnParams("contractAgreementList"),
        ...data,
      });
    },
    //
    async changeMaterialName(prop) {
      const { row } = prop;
      const { rateCode } = row;
      try {
        // try
        this.loading = true;
        const { ntaxrate } = await tax(rateCode);
        row.tax = ntaxrate === "0E-8" ? 0 : ntaxrate;
      } catch (err) {
        // catch
        console.error(err);
      } finally {
        // finally
        this.loading = false;
      }
    },
    //
    async open() {
      try {
        //
        this.loading = true;
        this.loadingText = "获取合同编码中";
        //
        const {
          user: {
            deptId: puDept,
            deptName: puDeptName,
            name: buyer,
            nickName: buyerName,
            orgId: puOrg,
            orgName: puOrgName,
          },
        } = this.$store.state;
        // this.params.puOrg = puOrg;
        // this.params.puOrgName = puOrgName;
        this.params.buyer = buyer;
        this.params.buyerName = buyerName;
        this.params.puDept = puDept;
        this.params.puDeptName = puDeptName;
        //
        const { title } = this.$props;
        this.params.source = title === "新增" ? "自制" : "期初补录";
        //
        const { id, code, name } = await currency("人民币");
        this.params.currency = id;
        this.params.currencyCode = code;
        this.params.currencyName = name;
        //
        this.params.code = await CODE();
        //
        this.loading = false;
      } catch (error) {
        this.loading = false;
        this.$notify.error(error);
      }
    },
    //
    async hide() {
      this.$emit("close");
    },
    //
    async useRowAdd(prop) {
      this.params[prop].push(this.getTabTableColumnParams(prop));
    },
    //
    async useRowRemove(prop, scope) {
      const { $index } = scope;
      this.params[prop].splice($index, 1);
    },
    //
    async useSubmit(prop) {
      this.$refs[prop].validate(async (valid) => {
        if (valid) {
          try {
            // try
            this.loading = true;
            this.loadingText = "提交合同中";
            const params = { ...this.params };
            const { msg, code } = await ADD(params);
            if (code === 200) {
              this.hide();
              this.$emit("submit-success");
              this.$notify.success(msg);
            }
          } catch (err) {
            // catch
            console.error(err);
          } finally {
            // finally
            this.loading = false;
          }
        } else {
          return false;
        }
      });
    },
  },
  created() {
    this.open();
  },
  mounted() {},
  destroyed() {},
};
</script>
<template>
  <div
    v-loading="loading"
    :element-loading-text="loadingText"
    style="height: 100vh; display: flex; flex-direction: column"
  >
    <div
      style="
        height: 50px;
        display: flex;
        justify-content: space-between;
        align-items: center;
        padding: 0 18px;
      "
    >
      <h4 class="m-0" style="font-weight: 500; flex: 1">{{ title }}</h4>
      <el-button
        type="primary"
        :size="$attrs.size"
        :loading="loading"
        @click="useSubmit('superForm')"
        >确 认</el-button
      >
      <el-button :size="$attrs.size" :loading="loading" @click="hide"
        >取 消</el-button
      >
    </div>
    <div v-if="params.code" style="flex: 1; overflow-y: auto">
      <el-super-form
        v-model="params"
        :dict="dict"
        :rules="rules"
        :size="$attrs.size"
        :columns="TableColumns"
        ref="superForm"
        label-width="auto"
        label-position="right"
        style="padding: 18px"
      >
        <template slot="paymentAgreement" slot-scope="scope">
          <component
            v-bind="scope.attr"
            v-model="scope.row[scope.item.key]"
            :size="$attrs.size"
            :source.sync="scope.row"
            @change="changePaymentAgreement({ ...scope, selectData: $event })"
          >
          </component>
        </template>
      </el-super-form>
    </div>
    <el-tabs v-if="params.code" v-model="tabName" style="margin: 0 18px 18px">
      <el-tab-pane
        v-for="{ item, TableColumns: columns } in TabColumns"
        :key="item.key"
        :label="item.title"
        :name="item.key"
        lazy
      >
        <div style="height: 25vh; display: flex">
          <el-super-table
            v-model="params[item.key]"
            :dict="dict"
            :ref="tabName"
            :columns="columns"
            :size="$attrs.size"
            index
          >
            <template slot="materialName" slot-scope="scope">
              <component
                v-bind="scope.attr"
                v-model="scope.row[scope.item.key]"
                :size="$attrs.size"
                :source.sync="scope.row"
                @change="changeMaterialName(scope)"
              >
              </component>
            </template>
            <el-table-column fixed="right" label="操作" width="75">
              <template slot="header" slot-scope="scope">
                <el-button
                  type="text"
                  :size="$attrs.size"
                  @click="useRowAdd(tabName)"
                  >增行
                </el-button>
              </template>
              <template slot-scope="scope">
                <el-button
                  type="text"
                  :size="$attrs.size"
                  @click.native.prevent="useRowRemove(tabName, scope)"
                  >删行
                </el-button>
              </template>
            </el-table-column>
          </el-super-table>
        </div>
      </el-tab-pane>
    </el-tabs>
  </div>
</template>
